// gcc damage.c -o damage -lX11 -lXdamage -Wall -g
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <X11/Xlib.h>
#include <X11/Xlibint.h>
#include <X11/extensions/Xdamage.h>

int main(int argc, char *argv[]) {
    int damage_event;
    int damage_error;
    int ret;
    Display *dpy;

    dpy = XOpenDisplay(NULL);
    assert(dpy);
    
    ret = XDamageQueryExtension(dpy, &damage_event, &damage_error);
    assert(ret);

    XDamageCreate(dpy,
                  DefaultRootWindow(dpy),
                  XDamageReportRawRectangles);
    
    for (;;) {
        XEvent event;
        XNextEvent(dpy, &event);
        if (event.type == damage_event + XDamageNotify) {
            XDamageNotifyEvent *e = (XDamageNotifyEvent *)(&event);
            printf("%d %d %d %d\n",
                   e->area.x,
                   e->area.y,
                   e->area.width,
                   e->area.height);
        }
    }
    return 0;
}
