#!/usr/bin/perl -w
use strict;
use Time::HiRes;
use Time::Local;

sub get_pcf50633_time {
    open(my $fd, '<', '/sys/class/rtc/rtc0/since_epoch');
    my $ret = <$fd>;
    close($fd);
    chomp($ret);
    return $ret;
}

sub main {
    my $t0 = 1243211691.6; # -1 to 1
    my $p = 16216.4; # period
    my $t;
    if ($#ARGV == 0) {
	$t = $ARGV[0];
    } else {
	$t = get_pcf50633_time();
    }
    my $drift = ($t - $t0) / $p;
    print "$t - int($drift) = " . ($t - int($drift)) . "\n";
}

main();
