#!/usr/bin/python
#
# copyright 2008 Angus Ainslie <angus.ainslie@gmail.com>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

import alsaaudio
import sys
import pygtk
pygtk.require('2.0')
import gtk
import os

class Mixers:
    def __init__( self ):
        return

    def GetMixers( self ) :
        self.mixers = []
        for m in alsaaudio.mixers():
            mixer = alsaaudio.Mixer( m )
            self.mixers.append( mixer ) 
            
class Main:   
    def delete_event(self, widget, event, data=None):
        print "delete event occurred"
        return False

    def destroy(self, widget, data=None):
        gtk.main_quit()

    def __init__(self):
        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.window.connect("delete_event", self.delete_event)
        self.window.connect("destroy", self.destroy)
        self.window.set_border_width(10)
#        self.window.set_size_request(400, 300)
        self.scrolled_window = gtk.ScrolledWindow()
        self.scrolled_window.set_policy(  gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC )

        mixers = Mixers()
        mixers.GetMixers()

        self.tabs = gtk.Notebook()
        
        #        self.CreateMixers( mixers.mixers )
        self.handsetMixers = self.CreateHandsetControls( mixers.mixers )
        self.wHeadsetMixers = self.CreateWiredHeadsetControls( mixers.mixers )
        self.speakeroutMixers = self.CreateSpeakeroutControls( mixers.mixers )
        self.btHeadsetMixers = self.CreateBtHeadsetControls( mixers.mixers )

        handsetLabel = gtk.Label( "Handset" )
        self.tabs.append_page( self.handsetMixers, handsetLabel )
        handsetLabel.show()
        wHeadsetLabel = gtk.Label( "Headset" )
        self.tabs.append_page( self.wHeadsetMixers, wHeadsetLabel )
        wHeadsetLabel.show()
        speakeroutLabel = gtk.Label( "Speaker" )
        self.tabs.append_page( self.speakeroutMixers, speakeroutLabel )
        speakeroutLabel.show()
        btHeadsetLabel = gtk.Label( "BT Headset" )
        self.tabs.append_page( self.btHeadsetMixers, btHeadsetLabel )
        btHeadsetLabel.show()
        
        self.window.add( self.tabs )
        self.handsetMixers.show()
        self.wHeadsetMixers.show()
        self.speakeroutMixers.show()
        self.btHeadsetMixers.show()
        self.tabs.show()
        
        #self.window.add( self.scrolled_window )
        #self.scrolled_window.add_with_viewport( self.handsetMixers )
        
        self.handsetMixers.show()
#        self.scrolled_window.show()
        self.window.show()

    def cb_volume( self, adj, m, idx, style = 'All' ) :
        volume = int( adj.get_value() );
        print "value changed :", volume, m.mixer(), idx

        volumes = m.getvolume()

        if( style == 'Single' ) :
            for i in range(len(volumes)) :
                m.setvolume(volume,i)
        else :
            m.setvolume(volume,idx)
     
        volumes = m.getvolume()

        if volume != volumes[idx] :
            adj.set_value( volumes[idx] )
        print "value now :", volumes[idx], m.mixer()

    def cb_mute( self, button, m, i ) :
        print "event"
        if button.get_active() == False :
            muted = "on"
            m.setmute( 1 )
#            button.set_active( False )
        else :
            muted = "off"
            m.setmute( 0 )
#            button.set_active( True )

        print m.mixer(), "mute", muted
    
    def cb_record( self, button, m, i ) :
        print "event"
        if button.get_active() == False :
            rec = "on"
            m.setrec( 1 )
#            button.set_active( False )
        else :
            rec = "off"
            m.setrec( 0 )
#           button.set_active( True )

        print m.mixer(), "record", rec

    def CreateMixerControls( self, m, style = 'All' ) :
        vbox = gtk.VBox( False, 1 )
        hbox = gtk.HBox( False, 1 )
        #            vbox.pack_start( hbox, True, False, 0 )
        label = gtk.Label( m.mixer() )
        label.show()
        hbox.show()

        print "Mixer name: '%s' '%d" %( m.mixer(),m.mixerid() )
        volcap = m.volumecap()
        switchcap = m.switchcap()
        print "Capabilities", volcap + switchcap

#        try :
#            mute = m.getmute()
#            print "mute", mute
#        except alsaaudio.ALSAAudioError:
            # May not support muting
#            mute = None
#            pass

	# Don't want mute for now 
	mute = None

        volumes = m.getvolume()
        if volcap and volumes :
            hbox.pack_start( label, True, False, 0 )
            vbox.pack_end( hbox, True, True, 0 )

            if( style == 'Single' ) :
                slides = 1
            if( style == 'All' ) :
                slides = len(volumes)
            for i in range( slides ):
                print "Channel %i volume: %i%%"%(i,volumes[i])
                hbox = gtk.HBox( False, 1 )
                        
                label = gtk.Label( "M" )
                        
                muteButton = gtk.ToggleButton()
                if mute != None and mute[i] != None :
                    muteButton.connect( "released", self.cb_mute, m, i )

                    if mute[i] == 0 :
                        muteButton.set_active( True )
                    else :
                        muteButton.set_active( False )

                    label.show()
                    muteButton.show()
                    hbox.pack_start( label, False, False, 0 )
                    hbox.pack_start( muteButton, False, False, 0 )
                else :
                    muteButton.set_sensitive( False )
                    label.set_sensitive( False )

                adjustment = gtk.Adjustment( volumes[i], 0, 101, 1, 10, 1 )
                adjustment.connect( "value_changed", self.cb_volume, m, i, style )

                scale = gtk.HScale( adjustment )
                scale.set_value_pos( gtk.POS_RIGHT )
                scale.set_digits(0)
                scale.set_size_request(300,50)
                #                vscale.set_inverted( True )
                hbox.pack_start( scale, True, True, 0 )
                hbox.show()
                vbox.pack_start( hbox, True, True, 0 )
                scale.show()
        else :
            return None

        return vbox
    
    def SaveState( self, arg, stateFile ) :
        oldFile = '/usr/share/openmoko/scenarios/' + stateFile + '.backup'
        newFile = '/usr/share/openmoko/scenarios/' + stateFile

        try :
            os.rename( newFile, oldFile )
        except :
            print 'No old file to backup'
        
        os.system( 'alsactl store 0 -f ' + newFile )

    def SetState( self, arg, stateFile ) :
        path = '/usr/share/openmoko/scenarios/' + stateFile

        os.system( 'alsactl restore 0 -f ' + path )


    def CreateHandsetControls( self , mixers ) :
        mixerBox = gtk.VBox( False, 1 )

        label = gtk.Label( "Output" )
        mixerBox.pack_start( label, True, False, 0 )
        label.show()

        for m in mixers:
            mixer = False
            id = m.mixerid()
            print "Mixer ", id ,": ", m.mixer()
            if m.mixer() == 'Mic2' :
                mixer = True
            if m.mixer() == 'Mono Sidetone' :
                mixer = True
            if m.mixer() == 'Mono' :
                mixer = True
            
            if mixer == True :
                mixerControls = self.CreateMixerControls( m, 'Single' ) 

                if mixerControls != None :
                    mixerBox.pack_start( mixerControls, True, False, 0 )
                    mixerControls.show()

        label = gtk.Label( "Input" )
        mixerBox.pack_start( label, True, False, 0 )
        label.show()

        for m in mixers:
            mixer = False
            id = m.mixerid()
            print "Mixer ", id ,": ", m.mixer()
            if m.mixer() == 'Bypass' :
                mixer = True
            if m.mixer() == 'Speaker' :
                mixer = True
            
            if mixer == True :
                mixerControls = self.CreateMixerControls( m, 'Single' ) 

                if mixerControls != None :
                    mixerBox.pack_start( mixerControls, True, False, 0 )
                    mixerControls.show()

        button = gtk.Button( "Save" );
        button.connect( "released", self.SaveState, 'gsmhandset.state'  )
        mixerBox.pack_start( button, True, False, 0 )
        button.show()

        button = gtk.Button( "Restore" );
        button.connect( "released", self.SetState, 'gsmhandset.state'  )
        mixerBox.pack_start( button, True, False, 0 )
        button.show()

        return( mixerBox )

    def CreateWiredHeadsetControls( self , mixers ) :
        mixerBox = gtk.VBox( False, 1 )

        label = gtk.Label( "Output" )
        mixerBox.pack_start( label, True, False, 0 )
        label.show()

        for m in mixers:
            mixer = False
            id = m.mixerid()
            print "Mixer ", id ,": ", m.mixer()
            if m.mixer() == 'Mic1' :
                mixer = True
            if m.mixer() == 'Mono Sidetone' :
                mixer = True
            if m.mixer() == 'Mono' :
                mixer = True

            if mixer == True :
                mixerControls = self.CreateMixerControls( m, 'Single' )

                if mixerControls != None :
                    mixerBox.pack_start( mixerControls, True, False, 0 )
                    mixerControls.show()

        label = gtk.Label( "Input" )
        mixerBox.pack_start( label, True, False, 0 )
        label.show()

        for m in mixers:
            mixer = False
            id = m.mixerid()
            print "Mixer ", id ,": ", m.mixer()
            if m.mixer() == 'Bypass' :
                mixer = True
            if m.mixer() == 'Headphone' :
                mixer = True
            
            if mixer == True :
                mixerControls = self.CreateMixerControls( m, 'Single' ) 

                if mixerControls != None :
                    mixerBox.pack_start( mixerControls, True, False, 0 )
                    mixerControls.show()

        button = gtk.Button( "Save" );
        button.connect( "released", self.SaveState, 'gsmheadset.state'  )
        mixerBox.pack_start( button, True, False, 0 )
        button.show()

        button = gtk.Button( "Restore" );
        button.connect( "released", self.SetState, 'gsmheadset.state'  )
        mixerBox.pack_start( button, True, False, 0 )
        button.show()

        return( mixerBox )

    def CreateSpeakeroutControls( self , mixers ) :
        mixerBox = gtk.VBox( False, 1 )

        label = gtk.Label( "Output" )
        mixerBox.pack_start( label, True, False, 0 )
        label.show()

        for m in mixers:
            mixer = False
            id = m.mixerid()
            print "Mixer ", id ,": ", m.mixer()
            if m.mixer() == 'Mic2' :
                mixer = True
            if m.mixer() == 'Mono Sidetone' :
                mixer = True
            if m.mixer() == 'Mono' :
                mixer = True
            
            if mixer == True :
                mixerControls = self.CreateMixerControls( m, 'Single' ) 

                if mixerControls != None :
                    mixerBox.pack_start( mixerControls, True, False, 0 )
                    mixerControls.show()

        label = gtk.Label( "Input" )
        mixerBox.pack_start( label, True, False, 0 )
        label.show()

        for m in mixers:
            mixer = False
            id = m.mixerid()
            print "Mixer ", id ,": ", m.mixer()
            if m.mixer() == 'Bypass' :
                mixer = True
            if m.mixer() == 'Headphone' :
                mixer = True
            
            if mixer == True :
                mixerControls = self.CreateMixerControls( m, 'Single' ) 

                if mixerControls != None :
                    mixerBox.pack_start( mixerControls, True, False, 0 )
                    mixerControls.show()

        button = gtk.Button( "Save" );
        button.connect( "released", self.SaveState, 'gsmspeakerout.state'  )
        mixerBox.pack_start( button, True, False, 0 )
        button.show()

        button = gtk.Button( "Restore" );
        button.connect( "released", self.SetState, 'gsmspeakerout.state'  )
        mixerBox.pack_start( button, True, False, 0 )
        button.show()

        return( mixerBox )
    
    def CreateBtHeadsetControls( self , mixers ) :
        mixerBox = gtk.VBox( False, 1 )

        label = gtk.Label( "Output" )
        mixerBox.pack_start( label, True, False, 0 )
        label.show()

        for m in mixers:
            mixer = False
            id = m.mixerid()
            print "Mixer ", id ,": ", m.mixer()
            if m.mixer() == 'Mono Voice Playback Volume' :
                mixer = True
            if m.mixer() == 'Mono' :
                mixer = True
            
            if mixer == True :
                mixerControls = self.CreateMixerControls( m, 'Single' ) 

                if mixerControls != None :
                    mixerBox.pack_start( mixerControls, True, False, 0 )
                    mixerControls.show()

        label = gtk.Label( "Input" )
        mixerBox.pack_start( label, True, False, 0 )
        label.show()

        for m in mixers:
            mixer = False
            id = m.mixerid()
            print "Mixer ", id ,": ", m.mixer()
            if m.mixer() == 'ADC' :
                mixer = True
            
            if mixer == True :
                mixerControls = self.CreateMixerControls( m, 'Single' ) 

                if mixerControls != None :
                    mixerBox.pack_start( mixerControls, True, False, 0 )
                    mixerControls.show()

        button = gtk.Button( "Save" );
        button.connect( "released", self.SaveState, 'btheadset.state'  )
        mixerBox.pack_start( button, True, False, 0 )
        button.show()

        button = gtk.Button( "Restore" );
        button.connect( "released", self.SetState, 'btheadset.state'  )
        mixerBox.pack_start( button, True, False, 0 )
        button.show()

        return( mixerBox )
    
    def CreateMixers( self, mixers ) :
        self.mixerBox = gtk.VBox( False, 1 )

        for m in mixers:
            label = gtk.Label( m.mixer() )
#            label.set_angle( 270 )
            vbox = gtk.VBox( False, 1 )
            hbox = gtk.HBox( False, 1 )
#            vbox.pack_start( hbox, True, False, 0 )
            self.mixerBox.pack_start( vbox, True, False, 0 )
            label.show()
            hbox.show()

            print "Mixer name: '%s'" %m.mixer()
            volcap = m.volumecap()
            switchcap = m.switchcap()
            print "Capabilities", volcap + switchcap

            try :
                mute = m.getmute()
                print "mute", mute
            except alsaaudio.ALSAAudioError:
                # May not support muting
                mute = None
                pass

            try :
                rec = m.getrec()
                print "record", rec
            except alsaaudio.ALSAAudioError:
                # May not support muting
                rec = None
                pass

            volumes = m.getvolume()
            if volcap and volumes :
                hbox.pack_start( label, True, False, 0 )
                vbox.pack_end( hbox, True, True, 0 )
                for i in range(len(volumes)):
                    print "Channel %i volume: %i%%"%(i,volumes[i])
                    hbox = gtk.HBox( False, 1 )
                
                    label = gtk.Label( "M" )
                
                    muteButton = gtk.ToggleButton()
                    if mute != None and mute[i] != None :
                        muteButton.connect( "released", self.cb_mute, m, i )
                        if mute[i] == 0 :
                            muteButton.set_active( True )
                        else :
                            muteButton.set_active( False )
                    else :
                        muteButton.set_sensitive( False )
                        label.set_sensitive( False )

                    label.show()
                    muteButton.show()
                    hbox.pack_start( label, False, False, 0 )
                    hbox.pack_start( muteButton, False, False, 0 )

                    label = gtk.Label( "R" )
                
                    recButton = gtk.ToggleButton()
                    if rec != None and rec[i] != None :
                        recButton.connect( "released", self.cb_record, m, i )
                        if rec[i] == 0 :
                            recButton.set_active( True )
                        else :
                            recButton.set_active( False )
                    else :
                        recButton.set_sensitive( False )
                        label.set_sensitive( False )

                    label.show()
                    recButton.show()
                    hbox.pack_start( label, False, False, 0 )
                    hbox.pack_start( recButton, False, False, 0 )

                    adjustment = gtk.Adjustment( volumes[i], 0, 101, 1, 10, 1 )
                    adjustment.connect( "value_changed", self.cb_volume, m, i )
                    scale = gtk.HScale( adjustment )
                    scale.set_value_pos( gtk.POS_RIGHT )
                    scale.set_digits(0)
                    scale.set_size_request(300,15)
                #                vscale.set_inverted( True )
                    hbox.pack_start( scale, True, True, 0 )
                    hbox.show()
                    vbox.pack_start( hbox, True, True, 0 )
                    scale.show()
            else :
                hbox.pack_start( label, False, False, 10 )
                vbox.pack_end( hbox, True, True, 10 )
                label = gtk.Label( "Mute" )
                muteButton = gtk.ToggleButton()
                if mute != None and mute[0] != None :
                    muteButton.connect( "released", self.cb_mute, m, i )
                    if mute[0] == 0 :
                        muteButton.set_active( True )
                    else :
                        muteButton.set_active( False )
                else :
                    muteButton.set_sensitive( False )
                    label.set_sensitive( False )

                label.show()
                muteButton.show()
                hbox.pack_start( label, False, False, 0 )
                hbox.pack_start( muteButton, False, False, 5 )
                
                label = gtk.Label( "Record" )
                
                recButton = gtk.ToggleButton()
                if rec != None and rec[0] != None :
                    recButton.connect( "released", self.cb_record, m, i )
                    if rec[0] == 0 :
                        recButton.set_active( True )
                    else :
                        recButton.set_active( False )
                else :
                    recButton.set_sensitive( False )
                    label.set_sensitive( False )
                    
                label.show()
                recButton.show()

                hbox.pack_start( label, False, False, 0 )
                hbox.pack_start( recButton, False, False, 5 )

                #hbox.show()
#                vbox.pack_start( hbox, True, True, 0 )

            vbox.show()
                
    def main(self):
        gtk.main()
    
run = Main()
run.main()
