#include <stdio.h>
#include <signal.h>
#include <assert.h>
#include <stdlib.h>

#define BUFSIZE (1<<20)

static int sigint_seen = 0;

void sigint_handler(int dummy) {
    sigint_seen = 1;
}

int main(int argc, char *argv[]) {
    char *buf;
    unsigned int start, end, i;
    int ret;
    start = end = 0;

    buf = malloc(BUFSIZE);
    assert(buf);

    signal(SIGINT, sigint_handler);

    for (;;) {
        ret = getchar();
        if (ret == EOF || sigint_seen) {
            break;
        }
        buf[end % BUFSIZE] = ret;
        end++;
        if (end - start > BUFSIZE) {
            start = end - BUFSIZE;
        }
    }

    for (i = start; i != end; i++) {
        putchar(buf[i % BUFSIZE]);
    }
    return 0;    
}
